/* =========================================================================
	This library is part of IshiSoft CEHTTP base class.
	------------------------------------------------------------------------
	author: yu-ishi@ya2.so-net.ne.jp
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(__CEHTTP_H__)
#define __CEHTTP_H__

#define MY_NOTIFYICON	(WM_APP + 1000)
#define WSTR_MSGBOX_TILTE	L"CEHTTP"
#define	HEADER_LINE_MAX	512		// HeaderLines max size

#if !defined(_WIN32_WCE)
	#define LOGAPIFILE			L"\\pchttplog.dll"		//
#else
	#define LOGAPIFILE			L"\\cehttplog.dll"		//
#endif

#define ERRORHTMLFILE		L"\\ErrorDocument.txt"		//
#define LOG_SEND_DATA		"send_bytes"				// Bytes count for logfile
#define LOG_REQUEST_LINE	"request_line"				// Request line for logfile
#define LOG_REMOTE_HOST		"remote_host"				// Remotehost for logfile

#if !defined(_WIN32_WCE)
	#define FNC_EXTEND_DLL	"fnCAPI"
	#define FNC_EXTEND_CHX	"fnChx"
	#define FNC_LOG_API		"fnCehttpLog"
#else
	#define FNC_EXTEND_DLL	L"fnCAPI"
	#define FNC_EXTEND_CHX	L"fnChx"
	#define FNC_LOG_API		L"fnCehttpLog"
#endif

#if defined(WIN32)
	#include "windows.h"
	#define MALLOC( size )		HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size )
	#define REALLOC( p, size )	HeapReAlloc( GetProcessHeap(), HEAP_ZERO_MEMORY, p, size )
//	#define FREE( p )			HeapFree( GetProcessHeap(), HEAP_NO_SERIALIZE, p )
	#define FREEIF( p )			{if(p) HeapFree( GetProcessHeap(), HEAP_NO_SERIALIZE, p );p=NULL;}
#else
	#include <malloc.h>
	#define MALLOC( size )		malloc( size )
	#define REALLOC( p, size )	realloc( p, size )
	#define FREE( p )			free( p )
	#define FREEIF( p )			{if(p) free(p);p=NULL;}
#endif

//-----------------------------------------------
enum HTTPCMD
{
	HTTPUNKNOWN = 0,	// bad request
	HTTPHEAD,			// Implemented
	HTTPGET,			// Implemented
	HTTPPOST,
	/* Not Implemented
	HTTPPUT,
	HTTPDELETE,
	HTTPTRACE,
	HTTPOPTIONS,
	HTTPCONNECT,
	HTTPLINK,
	HTTPUNLINK
	*/
	HTTPNOTIMPLEMENTED
};

//-----------------------------------------------
// Server infomation.(pointers)
//-----------------------------------------------
typedef struct tagServerInfo
{
	int		nPort;
	char*	pszSoftware;
	char*	pszDocRootName;
	char*	pszCgiRootName;
	char*	pszDefaultDocName;
	char*	pszAccessFileName;
	WCHAR*	pwszLogFile;
	int		nLogSize;
	int		nDNSLookup;
} SERVER_INFO, *LPSERVER_INFO;


#endif // !defined(__CEHTTP_H__)
