/* =========================================================================
	This library is part of IshiSoft CEHTTP base class.
	------------------------------------------------------------------------
	author: yu-ishi@ya2.so-net.ne.jp
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(AFX_MYHTTPSOCK_H__EAA73A6E_8C40_4F9B_8BC3_72CF9A94131F__INCLUDED_)
#define AFX_MYHTTPSOCK_H__EAA73A6E_8C40_4F9B_8BC3_72CF9A94131F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MySock.h"
#include "MyVarMem.h"
#include "MyHash.h"
#include "MyContentType.h"

//-----------------------------------------------
// CONTENT_TYPE
//-----------------------------------------------
typedef struct tagCONTENT_TYPE
{
	const char* pszExt;
	const char* pszMIME;
} CONTENT_TYPE, *LPCONTENT_TYPE;

//-----------------------------------------------
// HTTP_REQUEST
// The information client request is collected.
//-----------------------------------------------
typedef struct tagHTTP_REQUEST
{
	// Request line
	HTTPCMD			HttpCmd;				// GET, HEAD, POST,...
	char			szUrlPath[MAX_PATH];	// Url path
	char			szFilePath[MAX_PATH];	// File path of local file system
	char			szHttpVer[16];			// HTTP version of request
	
	WIN32_FIND_DATA	wfdFile;				// File information
	sockaddr_in*	psaRemoteHost;			// Remote host

} HTTP_REQUEST, *LPHTTP_REQUEST;

//-----------------------------------------------
// Relation with HTTPSTATUS and strings.
//-----------------------------------------------
typedef struct tagHTTP_STATUS
{
	int nStatus;
	const char* pszString;
} HTTP_STATUS, *LPHTTP_STATUS;

//-----------------------------------------------
class MyHttpSock : public MySock  
{
public:
	MyHttpSock(SOCKET s);
	MyHttpSock();
	virtual ~MyHttpSock();

	LPSERVER_INFO	m_pServerInfo;	// Servers infomation
	MyHash			m_hashReqHeader;// Request header lines
	MyHash			m_hashEnv;		// Environment
	HTTP_REQUEST	m_hrHttpReq;	// HTTP_REQUEST
	MyVarMem		m_hReqHead;		// HTTP request header
	MyVarMem		m_hReqBody;		// HTTP request body



public:
	void	FreeMemory();
	int		SendResponse(int nHttpStatus, int bConnectionClose = 1);
	int		RecvRequest(int* pbConnectionClose);

protected:
	DWORD	m_dwRecvTimeOut;
protected:
	int		ExecuteDll(char* pwszFile, int bClose);
	int		ExecuteChx(char* tszFile, int bClose);
	int		ExecuteCGI(char* tszFile, int bClose);
	int		CheckBasicAuth(int nHttpStatus, const char* pszFilePath, const char* pszBAuthFile);
	int		CheckBasicAuthFile(int nHttpStatus, char* pszAuthFilePath);
	
	int		SendHttpFile(int nHttpStatus, int bClose);
	int		Send401Response(int nHttpStatus, int bClose);
	int		Send999Response(int nHttpStatus, int bClose);
	int		SendDefaultHttpResponse(int nHttpStatus, int bConnectionClose = 0, int nAddtionalInfo = 0);
	
	void	MakeEnvironment();
	int		MakePath();

	int		ReadRequestHeaders(const char* pSrc);
	int		ReadRequestLine(const char* pSrc );
private:
};

#endif // !defined(AFX_MYHTTPSOCK_H__EAA73A6E_8C40_4F9B_8BC3_72CF9A94131F__INCLUDED_)
